/* M-800DATv(3.4KHz̐go	*/
/*	2005 (C)LogicPack		*/
#include <string.h>
#include "iodefine.h"
#include "lp.h"

#ifdef __cplusplus
extern "C" {
#endif
void abort(void);
#ifdef __cplusplus
}
#endif

/*-----------------------------------------------
/ *GLOBAL
/----------------------------------------------*/
volatile long	tim1ms;						/* ėp^C}JE^(msec) */

/*-----------------------------------------------
/ *DEFINE
/----------------------------------------------*/
#define SIN_DATA_MAX	63

#define CS3_ADDR	0x600000
#define CS4_ADDR	0x800000
#define CS5_ADDR	0xA00000
#define CS6_ADDR	0xC00000
#define CS7_ADDR	0xE00000

#define SEL0_ADDR	0x000
#define SEL1_ADDR	0x100
#define SEL2_ADDR	0x200
#define SEL3_ADDR	0x300
#define SEL4_ADDR	0x400
#define SEL5_ADDR	0x500
#define SEL6_ADDR	0x600
#define SEL7_ADDR	0x700
#define SEL8_ADDR	0x800
#define SEL9_ADDR	0x900
#define SELA_ADDR	0xA00
#define SELB_ADDR	0xB00
#define SELC_ADDR	0xC00
#define SELD_ADDR	0xD00
#define SELE_ADDR	0xE00
#define SELF_ADDR	0xF00

#define CHA_ADDR	0x0
#define CHB_ADDR	0x6
#define CHAB_ADDR	0x4
#define LDAC_ADDR	0x2

#define OFS_ADDR	(CS3_ADDR + SEL0_ADDR)

/*-----------------------------------------------
/ *STATIC
/----------------------------------------------*/
const word sin_table[SIN_DATA_MAX] = {
	32767,	36038,	39277,	42450,	45527,	48476,	51269, 	53876,
	56273,	58434,	60339,	61969,	63307,	64340,	65057,	65452,
	65520,	65261,	64677,	63774,	62562,	61052,	59259,	57202,
	54900,	52377,	49658,	46771,	43744,	40606,	37391,	34129,
	30854,	27598,	24394,	21273,	18267,	15406,	12718,	10231,
	 7969,	 5955,	 4208,	 2747,	 1586,	  736,	  207,	    3,
	  126,	  575,	 1346,	 2431,	 3819,	 5496,	 7446,	 9649,
	12082,	14723,	17543,	20516,	23611,	26798,	30044
};

/*-------------------------------------
/ wait
/------------------------------------*/
void wait(void)
{
	int i;
	for( i = 0; i < 10; i++ ){;}
}

/*-------------------------------------------------------------------
/ MAIN
/------------------------------------------------------------------*/
void main(void)
{
	int i;
	while(1){
		(*(volatile word *)(OFS_ADDR + CHA_ADDR)) = sin_table[i];
		(*(volatile word *)(OFS_ADDR + LDAC_ADDR)) = 0;
		if(++i == SIN_DATA_MAX){ i = 0; }
		wait();
	}
}
/*-------------------------------------------------------------------
/ abort
/------------------------------------------------------------------*/
void abort(void)
{
}
