/*----------------------------------------------------------------------------
/ CPU I/O
/	2005 (C)LogicPack
/	V1.00									2005.4.26			Suzuki
/---------------------------------------------------------------------------*/
#include "iodefine.h"
#ifdef __cplusplus
extern "C" {
#endif
extern void HardwareSetup();
#ifdef __cplusplus
}
#endif


/*
char        cDMAC0A_MAR[10];
int         iDMAC0B_MAR[10];
short       nDMAC1A_MAR[10];
long        lDMAC1B_MAR[10];
*/

void HardwareSetup()
{
	P1DDR = 0xff;		/* A7`A0 */
	P2DDR = 0xff;		/* A15`A8 */
	P5DDR = 0x03;		/* enable A17,A16 (mode5,7) */
/*
  P1DDR = 0;
  P1DR.BYTE = 0;
  P1DR.BIT.B7 = 1;
  P1DR.BIT.B6 = 1;
  P1DR.BIT.B5 = 1;
  P1DR.BIT.B4 = 1;
  P1DR.BIT.B3 = 1;
  P1DR.BIT.B2 = 1;
  P1DR.BIT.B1 = 1;
  P1DR.BIT.B0 = 1;

  P2DDR = 0;
  P2PCR.BYTE = 0;
  P2PCR.BIT.B7 = 1;
  P2PCR.BIT.B6 = 1;
  P2PCR.BIT.B5 = 1;
  P2PCR.BIT.B4 = 1;
  P2PCR.BIT.B3 = 1;
  P2PCR.BIT.B2 = 1;
  P2PCR.BIT.B1 = 1;
  P2PCR.BIT.B0 = 1;
  P2DR.BYTE = 0;
  P2DR.BIT.B7 = 1;
  P2DR.BIT.B6 = 1;
  P2DR.BIT.B5 = 1;
  P2DR.BIT.B4 = 1;
  P2DR.BIT.B3 = 1;
  P2DR.BIT.B2 = 1;
  P2DR.BIT.B1 = 1;
  P2DR.BIT.B0 = 1;

  P3DDR = 0;
  P3DR.BYTE = 0;
  P3DR.BIT.B7 = 1;
  P3DR.BIT.B6 = 1;
  P3DR.BIT.B5 = 1;
  P3DR.BIT.B4 = 1;
  P3DR.BIT.B3 = 1;
  P3DR.BIT.B2 = 1;
  P3DR.BIT.B1 = 1;
  P3DR.BIT.B0 = 1;

  P4DDR = 0;
  P4PCR.BYTE = 0;
  P4PCR.BIT.B7 = 1;
  P4PCR.BIT.B6 = 1;
  P4PCR.BIT.B5 = 1;
  P4PCR.BIT.B4 = 1;
  P4PCR.BIT.B3 = 1;
  P4PCR.BIT.B2 = 1;
  P4PCR.BIT.B1 = 1;
  P4PCR.BIT.B0 = 1;
  P4DR.BYTE = 0;
  P4DR.BIT.B7 = 1;
  P4DR.BIT.B6 = 1;
  P4DR.BIT.B5 = 1;
  P4DR.BIT.B4 = 1;
  P4DR.BIT.B3 = 1;
  P4DR.BIT.B2 = 1;
  P4DR.BIT.B1 = 1;
  P4DR.BIT.B0 = 1;

  P5DDR = 0;
  P5PCR.BYTE = 0;
  P5PCR.BIT.B3 = 1;
  P5PCR.BIT.B2 = 1;
  P5PCR.BIT.B1 = 1;
  P5PCR.BIT.B0 = 1;
  P5DR.BYTE = 0;
  P5DR.BIT.B3 = 1;
  P5DR.BIT.B2 = 1;
  P5DR.BIT.B1 = 1;
  P5DR.BIT.B0 = 1;

  P6DDR = 0;
  P6DR.BYTE = 0;
  P6DR.BIT.B7 = 1;
  P6DR.BIT.B6 = 1;
  P6DR.BIT.B5 = 1;
  P6DR.BIT.B4 = 1;
  P6DR.BIT.B3 = 1;
  P6DR.BIT.B2 = 1;
  P6DR.BIT.B1 = 1;
  P6DR.BIT.B0 = 1;

  P7DR.BYTE = 0;
  P7DR.BIT.B7 = 1;
  P7DR.BIT.B6 = 1;
  P7DR.BIT.B5 = 1;
  P7DR.BIT.B4 = 1;
  P7DR.BIT.B3 = 1;
  P7DR.BIT.B2 = 1;
  P7DR.BIT.B1 = 1;
  P7DR.BIT.B0 = 1;

  P8DDR = 0;
  P8DR.BYTE = 0;
  P8DR.BIT.B4 = 1;
  P8DR.BIT.B3 = 1;
  P8DR.BIT.B2 = 1;
  P8DR.BIT.B1 = 1;
  P8DR.BIT.B0 = 1;
*/
	P8DDR = 0x0e;	/* /CS1 /CS2 /CS3 */
/*

  P9DDR = 0;
  P9DR.BYTE = 0;
  P9DR.BIT.B5 = 1;
  P9DR.BIT.B4 = 1;
  P9DR.BIT.B3 = 1;
  P9DR.BIT.B2 = 1;
  P9DR.BIT.B1 = 1;
  P9DR.BIT.B0 = 1;


  PADDR = 0xe0;
  PADR.BYTE = 0;
  PADR.BIT.B7 = 1;
  PADR.BIT.B6 = 1;
  PADR.BIT.B5 = 1;
  PADR.BIT.B4 = 0;
  PADR.BIT.B3 = 0;
  PADR.BIT.B2 = 0;
  PADR.BIT.B1 = 0;
  PADR.BIT.B0 = 0;
*/


  PADDR = 0xff;			// output
  PADR.BYTE = 0;

  PBDDR = 0xff;			// output
  PBDR.BYTE = 0;

/*
  MDCR.BYTE = 0;
  MDCR.BIT.MDS = 7;

  SYSCR.BYTE = 0;
  SYSCR.BIT.SSBY  = 1;
  SYSCR.BIT.STS   = 7;
  SYSCR.BIT.UE    = 1;
  SYSCR.BIT.NMIEG = 1;
  SYSCR.BIT.SSOE  = 1;
  SYSCR.BIT.RAME  = 1;

  DIVCR.BYTE = 0;
  DIVCR.BIT.DIV = 3;

  MSTCR.WORD = 0;
  MSTCR.BYTE.H = 0;
  MSTCR.BYTE.L = 0;
  MSTCR.BIT.PSTOP  = 1;
  MSTCR.BIT.MSTPH2 = 1;  // SCI2
  MSTCR.BIT.MSTPH1 = 1;  // SCI1
  MSTCR.BIT.MSTPH0 = 1;  // SCO0
  MSTCR.BIT.MSTPL7 = 1;  // DMAC
  MSTCR.BIT.MSTPL5 = 1;  // DRAM
  MSTCR.BIT.MSTPL4 = 1;  // ITU
  MSTCR.BIT.MSTPL3 = 1;  // TMR0,1
  MSTCR.BIT.MSTPL2 = 1;  // TMR2,3
  MSTCR.BIT.MSTPL0 = 1;  // A/D

  BSC.BRCR.BYTE = 0;
  BSC.BRCR.BIT.A23E = 1;
  BSC.BRCR.BIT.A22E = 1;
  BSC.BRCR.BIT.A21E = 1;
  BSC.BRCR.BIT.A20E = 1;
  BSC.BRCR.BIT.BRLE = 1;
  BSC.CSCR.BYTE = 0;
  BSC.CSCR.BIT.CS7E = 1;
  BSC.CSCR.BIT.CS6E = 1;
  BSC.CSCR.BIT.CS5E = 1;
  BSC.CSCR.BIT.CS4E = 1;
  BSC.ABWCR.BYTE = 0;
  BSC.ABWCR.BIT.B7 = 1;
  BSC.ABWCR.BIT.B6 = 1;
  BSC.ABWCR.BIT.B5 = 1;
  BSC.ABWCR.BIT.B4 = 1;
  BSC.ABWCR.BIT.B3 = 1;
  BSC.ABWCR.BIT.B2 = 1;
  BSC.ABWCR.BIT.B1 = 1;
  BSC.ABWCR.BIT.B0 = 1;
  BSC.ASTCR.BYTE = 0;
  BSC.ASTCR.BIT.B7 = 1;
  BSC.ASTCR.BIT.B6 = 1;
  BSC.ASTCR.BIT.B5 = 1;
  BSC.ASTCR.BIT.B4 = 1;
  BSC.ASTCR.BIT.B3 = 1;
  BSC.ASTCR.BIT.B2 = 1;
  BSC.ASTCR.BIT.B1 = 1;
  BSC.ASTCR.BIT.B0 = 1;
  BSC.WCR.WORD = 0;
  BSC.WCR.BYTE.H = 0;
  BSC.WCR.BYTE.L = 0;
  BSC.WCR.BIT.W7 = 3;
  BSC.WCR.BIT.W6 = 3;
  BSC.WCR.BIT.W5 = 3;
  BSC.WCR.BIT.W4 = 3;
  BSC.WCR.BIT.W3 = 3;
  BSC.WCR.BIT.W2 = 3;
  BSC.WCR.BIT.W1 = 3;
  BSC.WCR.BIT.W0 = 3;
  BSC.BCR.BYTE = 0;
  BSC.BCR.BIT.ICIS1  = 1;
  BSC.BCR.BIT.ICIS0  = 1;
  BSC.BCR.BIT.BROME  = 1;
  BSC.BCR.BIT.BRSTS1 = 1;
  BSC.BCR.BIT.BRSTS0 = 1;
  BSC.BCR.BIT.RDEA   = 1;
  BSC.BCR.BIT.WAITE  = 1;
  BSC.DRCRA.BYTE = 0;
  BSC.DRCRA.BIT.DRAS  = 7;
  BSC.DRCRA.BIT.BE    = 1;
  BSC.DRCRA.BIT.RDM   = 1;
  BSC.DRCRA.BIT.SRFMD = 1;
  BSC.DRCRA.BIT.RFSHE = 1;
  BSC.DRCRB.BYTE = 0;
  BSC.DRCRB.BIT.MXC   = 3;
  BSC.DRCRB.BIT.CSEL  = 1;
  BSC.DRCRB.BIT.RCYCE = 1;
// #undef TPC
// BSC.DRCRB.BIT.TPC  = 1;
  BSC.DRCRB.BIT.RCW    = 1;
  BSC.DRCRB.BIT.RLW    = 1;
  BSC.RTMCSR.BYTE = 0;
  BSC.RTMCSR.BIT.CMF   = 1;
  BSC.RTMCSR.BIT.CMIE  = 1;
  BSC.RTMCSR.BIT.CKS   = 7;
  BSC.RTCNT = 0;
  BSC.RTCOR = 0;
*/
	/*-----[ /CS1(0x200000) -> SRAM ]-----*/
	BSC.ABWCR.BIT.ABW1 = 0;	/* 16bit bus */
	BSC.ASTCR.BIT.AST1 = 0;	/* 2state */
	BSC.WCR.BIT.W1 = 0;		/* nowait */

#if 0
	/*-----[ /CS2(0x400000) -> RTL8019A ]-----*/
	BSC.ABWCR.BIT.ABW2 = 0;	/* 16bit bus */
	BSC.ASTCR.BIT.AST2 = 1;	/* 3state */
	BSC.WCR.BIT.W2 = 0;		/* nowait */

	BSC.BCR.BIT.WAITE = 1;	/* /WAIT */
#endif

	/*-----[ /CS3(0x600000) -> M800DA ]-----*/
	BSC.ABWCR.BIT.ABW3 = 0;	/* 16bit bus */
	BSC.ASTCR.BIT.AST3 = 1;	/* 3state */
	BSC.WCR.BIT.W3 = 0;		/* nowait */

//	BSC.DRCRB.BIT.MXC = 2;
//	BSC.DRCRB.BIT.MXC = 0;
//	BSC.DRCRB.BIT.MXC = 1;
//	BSC.DRCRB.BIT.CSEL = 0;
//	BSC.DRCRB.BIT.RCYCE = 1;
//	BSC.RTMCSR.BIT.CKS   = 1;
//	BSC.DRCRA.BIT.BE    = 1;
//	BSC.DRCRA.BIT.BE    = 1;
//	BSC.DRCRA.BIT.DRAS = 1;
/*

  INTC.ISCR.BYTE = 0;
  INTC.ISCR.BIT.IRQ5SC = 1;
  INTC.ISCR.BIT.IRQ4SC = 1;
  INTC.ISCR.BIT.IRQ3SC = 1;
  INTC.ISCR.BIT.IRQ2SC = 1;
  INTC.ISCR.BIT.IRQ1SC = 1;
  INTC.ISCR.BIT.IRQ0SC = 1;
  INTC.IER.BYTE = 0;
  INTC.IER.BIT.IRQ5E = 1;
  INTC.IER.BIT.IRQ4E = 1;
  INTC.IER.BIT.IRQ3E = 1;
  INTC.IER.BIT.IRQ2E = 1;
  INTC.IER.BIT.IRQ1E = 1;
  INTC.IER.BIT.IRQ0E = 1;
  INTC.ISR.BYTE = 0;
  INTC.ISR.BIT.IRQ5F = 1;
  INTC.ISR.BIT.IRQ4F = 1;
  INTC.ISR.BIT.IRQ3F = 1;
  INTC.ISR.BIT.IRQ2F = 1;
  INTC.ISR.BIT.IRQ1F = 1;
  INTC.ISR.BIT.IRQ0F = 1;
  INTC.IPRA.BYTE = 0;
  INTC.IPRA.BIT.B7 = 1;  // Set IRQ0         Priority Level
  INTC.IPRA.BIT.B6 = 1;  // Set IRQ1         Priority Level
  INTC.IPRA.BIT.B5 = 1;  // Set IRQ2,IRQ3    Priority Level
  INTC.IPRA.BIT.B4 = 1;  // Set IRQ4,IRQ5    Priority Level
  INTC.IPRA.BIT.B3 = 1;  // Set WDT,DRAM,A/D Priority Level
  INTC.IPRA.BIT.B2 = 1;  // Set ITU0         Priority Level
  INTC.IPRA.BIT.B1 = 1;  // Set ITU1         Priority Level
  INTC.IPRA.BIT.B0 = 1;  // Set ITU2         Priority Level
  INTC.IPRB.BYTE = 0;
  INTC.IPRB.BIT.B7 = 1;  // Set TMR0,TMR1    Priority Level
  INTC.IPRB.BIT.B6 = 1;  // Set TMR2,TMR3    Priority Level
  INTC.IPRB.BIT.B5 = 1;  // Set DMAC         Priority Level
  INTC.IPRB.BIT.B3 = 1;  // Set SCI0         Priority Level
  INTC.IPRB.BIT.B2 = 1;  // Set SCI1         Priority Level
  INTC.IPRB.BIT.B1 = 1;  // Set SCI2         Priority Level

  FLMCR.BYTE = 0;
  FLMCR.BIT.FWE = 1;
  FLMCR.BIT.SWE = 1;
  FLMCR.BIT.ESU = 1;
  FLMCR.BIT.PSU = 1;
  FLMCR.BIT.EV  = 1;
  FLMCR.BIT.PV  = 1;
  FLMCR.BIT.E   = 1;
  FLMCR.BIT.P   = 1;
  EBR.BYTE = 0;
  EBR.BIT.EB7 = 1;
  EBR.BIT.EB6 = 1;
  EBR.BIT.EB5 = 1;
  EBR.BIT.EB4 = 1;
  EBR.BIT.EB3 = 1;
  EBR.BIT.EB2 = 1;
  EBR.BIT.EB1 = 1;
  EBR.BIT.EB0 = 1;
  RAMCR.BYTE = 0;
  RAMCR.BIT.RAMS = 7;
  FLMSR.BYTE = 0;
  FLMSR.BIT.FLER = 1;

  // DMAC used Short Address Mode
  DMAC0A.MAR = &cDMAC0A_MAR[0];
  DMAC0A.ETCR = 0;
  DMAC0A.IOAR = 0;
  DMAC0A.DTCR.BYTE = 0;
  DMAC0A.DTCR.BIT.DTE  = 1;
  DMAC0A.DTCR.BIT.DTSZ = 1;
  DMAC0A.DTCR.BIT.DTID = 1;
  DMAC0A.DTCR.BIT.RPE  = 1;
  DMAC0A.DTCR.BIT.DTIE = 1;
  DMAC0A.DTCR.BIT.DTS  = 7;

  DMAC0B.MAR = &iDMAC0B_MAR[0];
  DMAC0B.ETCR = 0;
  DMAC0B.IOAR = 0;
  DMAC0B.DTCR.BYTE = 0;
  DMAC0B.DTCR.BIT.DTE  = 1;
  DMAC0B.DTCR.BIT.DTSZ = 1;
  DMAC0B.DTCR.BIT.DTID = 1;
  DMAC0B.DTCR.BIT.RPE  = 1;
  DMAC0B.DTCR.BIT.DTIE = 1;
  DMAC0B.DTCR.BIT.DTS  = 7;

  DMAC1A.MAR = &nDMAC1A_MAR[0];
  DMAC1A.ETCR = 0;
  DMAC1A.IOAR = 0;
  DMAC1A.DTCR.BYTE = 0;
  DMAC1A.DTCR.BIT.DTE  = 1;
  DMAC1A.DTCR.BIT.DTSZ = 1;
  DMAC1A.DTCR.BIT.DTID = 1;
  DMAC1A.DTCR.BIT.RPE  = 1;
  DMAC1A.DTCR.BIT.DTIE = 1;
  DMAC1A.DTCR.BIT.DTS  = 7;

  DMAC1B.MAR = &lDMAC1B_MAR[0];
  DMAC1B.ETCR = 0;
  DMAC1B.IOAR = 0;
  DMAC1B.DTCR.BYTE = 0;
  DMAC1B.DTCR.BIT.DTE  = 1;
  DMAC1B.DTCR.BIT.DTSZ = 1;
  DMAC1B.DTCR.BIT.DTID = 1;
  DMAC1B.DTCR.BIT.RPE  = 1;
  DMAC1B.DTCR.BIT.DTIE = 1;
  DMAC1B.DTCR.BIT.DTS  = 7;

  // DMAC used full Address Mode
  DMAC0.MARA = &cDMAC0A_MAR[0];
  DMAC0.MARB = &iDMAC0B_MAR[0];
  DMAC0.ETCRA = 0;
  DMAC0.ETCRB = 0;
  DMAC0.DTCRA.BYTE = 0;
  DMAC0.DTCRA.BIT.DTE   = 1;
  DMAC0.DTCRA.BIT.DTSZ  = 1;
  DMAC0.DTCRA.BIT.SAID  = 1;
  DMAC0.DTCRA.BIT.SAIDE = 1;
  DMAC0.DTCRA.BIT.DTIE  = 1;
  DMAC0.DTCRA.BIT.DTS   = 7;
  DMAC0.DTCRB.BYTE = 0;
  DMAC0.DTCRB.BIT.DTME  = 1;
  DMAC0.DTCRB.BIT.DAID  = 1;
  DMAC0.DTCRB.BIT.DAIDE = 1;
  DMAC0.DTCRB.BIT.TMS   = 1;
  DMAC0.DTCRB.BIT.DTS   = 7;

  DMAC1.MARA = &nDMAC1A_MAR[0];
  DMAC1.MARB = &lDMAC1B_MAR[0];
  DMAC1.ETCRA = 0;
  DMAC1.ETCRB = 0;
  DMAC1.DTCRA.BYTE = 0;
  DMAC1.DTCRA.BIT.DTE   = 1;
  DMAC1.DTCRA.BIT.DTSZ  = 1;
  DMAC1.DTCRA.BIT.SAID  = 1;
  DMAC1.DTCRA.BIT.SAIDE = 1;
  DMAC1.DTCRA.BIT.DTIE  = 1;
  DMAC1.DTCRA.BIT.DTS   = 7;
  DMAC1.DTCRB.BYTE = 0;
  DMAC1.DTCRB.BIT.DTME  = 1;
  DMAC1.DTCRB.BIT.DAID  = 1;
  DMAC1.DTCRB.BIT.DAIDE = 1;
  DMAC1.DTCRB.BIT.TMS   = 1;
  DMAC1.DTCRB.BIT.DTS   = 7;

  ITU.TSTR.BYTE = 0;
  ITU.TSTR.BIT.STR2 = 1;
  ITU.TSTR.BIT.STR1 = 1;
  ITU.TSTR.BIT.STR0 = 1;
  ITU.TSNC.BYTE = 0;
  ITU.TSNC.BIT.SYNC2 = 1;
  ITU.TSNC.BIT.SYNC1 = 1;
  ITU.TSNC.BIT.SYNC0 = 1;
  ITU.TMDR.BYTE = 0;
  ITU.TMDR.BIT.MDF  = 1;
  ITU.TMDR.BIT.FDIR = 1;
  ITU.TMDR.BIT.PWM2 = 1;
  ITU.TMDR.BIT.PWM1 = 1;
  ITU.TMDR.BIT.PWM0 = 1;
  ITU.TOLR.BYTE = 0;
  ITU.TOLR.BIT.TOB2 = 1;
  ITU.TOLR.BIT.TOA2 = 1;
  ITU.TOLR.BIT.TOB1 = 1;
  ITU.TOLR.BIT.TOA1 = 1;
  ITU.TOLR.BIT.TOB0 = 1;
  ITU.TOLR.BIT.TOA0 = 1;
  ITU.TISRA.BYTE = 0;
  ITU.TISRA.BIT.IMIEA2 = 1;
  ITU.TISRA.BIT.IMIEA1 = 1;
  ITU.TISRA.BIT.IMIEA0 = 1;
  ITU.TISRA.BIT.IMFA2  = 1;
  ITU.TISRA.BIT.IMFA1  = 1;
  ITU.TISRA.BIT.IMFA0  = 1;
  ITU.TISRB.BYTE = 0;
  ITU.TISRB.BIT.IMIEB2 = 1;
  ITU.TISRB.BIT.IMIEB1 = 1;
  ITU.TISRB.BIT.IMIEB0 = 1;
  ITU.TISRB.BIT.IMFB2  = 1;
  ITU.TISRB.BIT.IMFB1  = 1;
  ITU.TISRB.BIT.IMFB0  = 1;
  ITU.TISRC.BYTE = 0;
  ITU.TISRC.BIT.OVIE2 = 1;
  ITU.TISRC.BIT.OVIE1 = 1;
  ITU.TISRC.BIT.OVIE0 = 1;
  ITU.TISRC.BIT.OVF2  = 1;
  ITU.TISRC.BIT.OVF1  = 1;
  ITU.TISRC.BIT.OVF0  = 1;
*/

#if 1
//  ITU0.TCR.BYTE = 0;
  ITU0.TCR.BIT.CCLR = 1;	// GRAv
  ITU0.TCR.BIT.CKEG = 0;	// オGbWJEg
  ITU0.TCR.BIT.TPSC = 3;	// CLK8
//  ITU0.TIOR.BYTE = 0;
//  ITU0.TIOR.BIT.IOB = 7;
//  ITU0.TIOR.BIT.IOA = 2;	// GRARyA}b`1o
  ITU0.TIOR.BIT.IOA = 0;	// GRARyA}b`֎~
  ITU0.TCNT = 0;
  ITU0.GRA = 3072;			// 1msec timer
//  ITU0.GRB = 0;

  ITU.TISRA.BIT.IMIEA0 = 1;	// GRARyA}b`tOɂ銄荞݋
  ITU.TSTR.BIT.STR0 = 1;	// JE^X^[g
  
  INTC.IPRA.BIT._ITU0 = 1;  // Set ITU0         Priority Level
#endif

/*
  ITU1.TCR.BYTE = 0;
  ITU1.TCR.BIT.CCLR = 3;
  ITU1.TCR.BIT.CKEG = 3;
  ITU1.TCR.BIT.TPSC = 7;
  ITU1.TIOR.BYTE = 0;
  ITU1.TIOR.BIT.IOB = 7;
  ITU1.TIOR.BIT.IOA = 7;
  ITU1.TCNT = 0;
  ITU1.GRA = 0;
  ITU1.GRB = 0;

  ITU2.TCR.BYTE = 0;
  ITU2.TCR.BIT.CCLR = 3;
  ITU2.TCR.BIT.CKEG = 3;
  ITU2.TCR.BIT.TPSC = 7;
  ITU2.TIOR.BYTE = 0;
  ITU2.TIOR.BIT.IOB = 7;
  ITU2.TIOR.BIT.IOA = 7;
  ITU2.TCNT = 0;
  ITU2.GRA = 0;
  ITU2.GRB = 0;

 // TMR0,TMR1 Used 16 Bit Timer
  TMR01.TCR0.BYTE = 0;
  TMR01.TCR0.BIT.CMIEB = 1;
  TMR01.TCR0.BIT.CMIEA = 1;
  TMR01.TCR0.BIT.OVIE  = 1;
  TMR01.TCR0.BIT.CCLR  = 3;
  TMR01.TCR0.BIT.CKS   = 7;
  TMR01.TCR1.BYTE = 0;
  TMR01.TCR1.BIT.CMIEB = 1;
  TMR01.TCR1.BIT.CMIEA = 1;
  TMR01.TCR1.BIT.OVIE  = 1;
  TMR01.TCR1.BIT.CCLR  = 3;
  TMR01.TCR1.BIT.CKS   = 7;
  TMR01.TCSR0.BYTE = 0;
  TMR01.TCSR0.BIT.CMFB = 1;
  TMR01.TCSR0.BIT.CMFA = 1;
  TMR01.TCSR0.BIT.OVF  = 1;
  TMR01.TCSR0.BIT.ADTE = 1;
  TMR01.TCSR0.BIT.OS   = 15;
  TMR01.TCSR1.BYTE = 0;
  TMR01.TCSR1.BIT.CMFB = 1;
  TMR01.TCSR1.BIT.CMFA = 1;
  TMR01.TCSR1.BIT.OVF  = 1;
  TMR01.TCSR1.BIT.ICE  = 1;
  TMR01.TCSR1.BIT.OS   = 15;
  TMR01.TCORA = 0;
  TMR01.TCORB = 0;
  TMR01.TCNT = 0;

 // TMR2,TMR3 Used 16 Bit Timer
  TMR23.TCR2.BYTE = 0;
  TMR23.TCR2.BIT.CMIEB = 1;
  TMR23.TCR2.BIT.CMIEA = 1;
  TMR23.TCR2.BIT.OVIE  = 1;
  TMR23.TCR2.BIT.CCLR  = 3;
  TMR23.TCR2.BIT.CKS   = 7;
  TMR23.TCR3.BYTE = 0;
  TMR23.TCR3.BIT.CMIEB = 1;
  TMR23.TCR3.BIT.CMIEA = 1;
  TMR23.TCR3.BIT.OVIE  = 1;
  TMR23.TCR3.BIT.CCLR  = 3;
  TMR23.TCR3.BIT.CKS   = 7;
  TMR23.TCSR2.BYTE = 0;
  TMR23.TCSR2.BIT.CMFB = 1;
  TMR23.TCSR2.BIT.CMFA = 1;
  TMR23.TCSR2.BIT.OVF  = 1;
  TMR23.TCSR2.BIT.OS   = 15;
  TMR23.TCSR3.BYTE = 0;
  TMR23.TCSR3.BIT.CMFB = 1;
  TMR23.TCSR3.BIT.CMFA = 1;
  TMR23.TCSR3.BIT.OVF  = 1;
  TMR23.TCSR3.BIT.ICE  = 1;
  TMR23.TCSR3.BIT.OS   = 15;
  TMR23.TCORA = 0;
  TMR23.TCORB = 0;
  TMR23.TCNT = 0;


 // TMR Used 8 Bit Timer
  TMR0.TCR.BYTE = 0;
  TMR0.TCR.BIT.CMIEB = 1;
  TMR0.TCR.BIT.CMIEA = 1;
  TMR0.TCR.BIT.OVIE  = 1;
  TMR0.TCR.BIT.CCLR  = 3;
  TMR0.TCR.BIT.CKS   = 15;
  TMR0.TCSR.BYTE = 0;
  TMR0.TCSR.BIT.CMFB = 1;
  TMR0.TCSR.BIT.CMFA = 1;
  TMR0.TCSR.BIT.OVF  = 1;
  TMR0.TCSR.BIT.ADTE = 1;
  TMR0.TCSR.BIT.OS   = 15;
  TMR0.TCORA = 0;
  TMR0.TCORB = 0;
  TMR0.TCNT = 0;

  TMR1.TCR.BYTE = 0;
  TMR1.TCR.BIT.CMIEB = 1;
  TMR1.TCR.BIT.CMIEA = 1;
  TMR1.TCR.BIT.OVIE  = 1;
  TMR1.TCR.BIT.CCLR  = 3;
  TMR1.TCR.BIT.CKS   = 7;
  TMR1.TCSR.BYTE = 0;
  TMR1.TCSR.BIT.CMFB = 1;
  TMR1.TCSR.BIT.CMFA = 1;
  TMR1.TCSR.BIT.OVF  = 1;
  TMR1.TCSR.BIT.ICE  = 1;
  TMR1.TCSR.BIT.OS   = 15;
  TMR1.TCORA = 0;
  TMR1.TCORB = 0;
  TMR1.TCNT = 0;

  TMR2.TCR.BYTE = 0;
  TMR2.TCR.BIT.CMIEB = 1;
  TMR2.TCR.BIT.CMIEA = 1;
  TMR2.TCR.BIT.OVIE  = 1;
  TMR2.TCR.BIT.CCLR  = 3;
  TMR2.TCR.BIT.CKS   = 7;
  TMR2.TCSR.BYTE = 0;
  TMR2.TCSR.BIT.CMFB = 1;
  TMR2.TCSR.BIT.CMFA = 1;
  TMR2.TCSR.BIT.OVF  = 1;
  TMR2.TCSR.BIT.OS   = 15;
  TMR2.TCORA = 0;
  TMR2.TCORB = 0;
  TMR2.TCNT = 0;

  TMR3.TCR.BYTE = 0;
  TMR3.TCR.BIT.CMIEB = 1;
  TMR3.TCR.BIT.CMIEA = 1;
  TMR3.TCR.BIT.OVIE  = 1;
  TMR3.TCR.BIT.CCLR  = 3;
  TMR3.TCR.BIT.CKS   = 7;
  TMR3.TCSR.BYTE = 0;
  TMR3.TCSR.BIT.CMFB = 1;
  TMR3.TCSR.BIT.CMFA = 1;
  TMR3.TCSR.BIT.OVF  = 1;
  TMR3.TCSR.BIT.ICE  = 1;
  TMR3.TCSR.BIT.OS   = 15;
  TMR3.TCORA = 0;
  TMR3.TCORB = 0;
  TMR3.TCNT = 0;

  DASTCR.BYTE = 0;
  DASTCR.BIT.DASTE = 1;
  DA.DR0 = 0;
  DA.DR1 = 0;
  DA.CR.BYTE = 0;
  DA.CR.BIT.DAOE1 = 1;
  DA.CR.BIT.DAOE0 = 1;
  DA.CR.BIT.DAE   = 1;

  TPC.TPMR.BYTE = 0;
  TPC.TPMR.BIT.G3NOV = 1;
  TPC.TPMR.BIT.G2NOV = 1;
  TPC.TPMR.BIT.G1NOV = 1;
  TPC.TPMR.BIT.G0NOV = 1;
  TPC.TPCR.BYTE = 0;
  TPC.TPCR.BIT.G3CMS = 3;
  TPC.TPCR.BIT.G2CMS = 3;
  TPC.TPCR.BIT.G1CMS = 3;
  TPC.TPCR.BIT.G0CMS = 3;
  TPC.NDERB.BYTE = 0;
  TPC.NDERB.BIT.B15 = 1;
  TPC.NDERB.BIT.B14 = 1;
  TPC.NDERB.BIT.B13 = 1;
  TPC.NDERB.BIT.B12 = 1;
  TPC.NDERB.BIT.B11 = 1;
  TPC.NDERB.BIT.B10 = 1;
  TPC.NDERB.BIT.B9  = 1;
  TPC.NDERB.BIT.B8  = 1;
  TPC.NDERA.BYTE = 0;
  TPC.NDERA.BIT.B7 = 1;
  TPC.NDERA.BIT.B6 = 1;
  TPC.NDERA.BIT.B5 = 1;
  TPC.NDERA.BIT.B4 = 1;
  TPC.NDERA.BIT.B3 = 1;
  TPC.NDERA.BIT.B2 = 1;
  TPC.NDERA.BIT.B1 = 1;
  TPC.NDERA.BIT.B0 = 1;
  TPC.NDRB1.BYTE = 0;     // Address is H'A4
  TPC.NDRB1.BIT.B15 = 1;
  TPC.NDRB1.BIT.B14 = 1;
  TPC.NDRB1.BIT.B13 = 1;
  TPC.NDRB1.BIT.B12 = 1;
  TPC.NDRB1.BIT.B11 = 1;
  TPC.NDRB1.BIT.B10 = 1;
  TPC.NDRB1.BIT.B9  = 1;
  TPC.NDRB1.BIT.B8  = 1;
  TPC.NDRB2.BYTE = 0;     // Address is H'A6
  TPC.NDRB2.BIT.B11 = 1;
  TPC.NDRB2.BIT.B10 = 1;
  TPC.NDRB2.BIT.B9  = 1;
  TPC.NDRB2.BIT.B8  = 1;
  TPC.NDRA1.BYTE = 0;     // Address is H'A5
  TPC.NDRA1.BIT.B7 = 1;
  TPC.NDRA1.BIT.B6 = 1;
  TPC.NDRA1.BIT.B5 = 1;
  TPC.NDRA1.BIT.B4 = 1;
  TPC.NDRA1.BIT.B3 = 1;
  TPC.NDRA1.BIT.B2 = 1;
  TPC.NDRA1.BIT.B1 = 1;
  TPC.NDRA1.BIT.B0 = 1;
  TPC.NDRA2.BYTE = 0;     // Address is H'A7
  TPC.NDRA2.BIT.B3 = 1;
  TPC.NDRA2.BIT.B2 = 1;
  TPC.NDRA2.BIT.B1 = 1;
  TPC.NDRA2.BIT.B0 = 1;
*/

#if 0
  SCI0.SCR.BYTE = 0;
  SCI0.SCR.BIT.CKE  = 0;	// SCK -> port

  SCI0.SCMR.BYTE = 0;

  SCI0.SMR.BYTE = 0;
  SCI0.SMR.BIT.CA   = 0;	// [h
  SCI0.SMR.BIT.CHR  = 0;	// 8bit charactor
  SCI0.SMR.BIT.PE   = 0;	// non parity
  SCI0.SMR.BIT.OE   = 0;
  SCI0.SMR.BIT.STOP = 0;	// 1stop bit
  SCI0.SMR.BIT.MP   = 0;	// non multi processer
  SCI0.SMR.BIT.CKS  = 0;	// 
  SCI0.BRR = 19;			// 38400bps
#endif
#if 0
  SCI1.SCR.BYTE = 0;
  SCI1.SCR.BIT.CKE  = 0;	// SCK -> port

  SCI1.SCMR.BYTE = 0;

  SCI1.SMR.BYTE = 0;
  SCI1.SMR.BIT.CA   = 0;	// [h
  SCI1.SMR.BIT.CHR  = 0;	// 8bit charactor
  SCI1.SMR.BIT.PE   = 0;	// non parity
  SCI1.SMR.BIT.OE   = 0;
  SCI1.SMR.BIT.STOP = 0;	// 1stop bit
  SCI1.SMR.BIT.MP   = 0;	// non multi processer
  SCI1.SMR.BIT.CKS  = 0;	// 
  SCI1.BRR = 19;			// 38400bps

  INTC.IPRB.BIT._SCI1 = 1;  // Set SCI1         Priority Level
#endif

//  SCI0.SCR.BIT.TIE  = 0;
//  SCI0.SCR.BIT.RIE  = 1;
//  SCI0.SCR.BIT.TE   = 1;
//  SCI0.SCR.BIT.RE   = 1;
//  SCI0.SCR.BIT.MPIE = 0;
//  SCI0.SCR.BIT.TEIE = 0;

/*
  SCI1.SMR.BYTE = 0;
  SCI1.SMR.BIT.CA   = 1;
  SCI1.SMR.BIT.CHR  = 1;
  SCI1.SMR.BIT.PE   = 1;
  SCI1.SMR.BIT.OE   = 1;
  SCI1.SMR.BIT.STOP = 1;
  SCI1.SMR.BIT.MP   = 1;
  SCI1.SMR.BIT.CKS  = 3;
  SCI1.BRR = 0;
  SCI1.SCR.BYTE = 0;
  SCI1.SCR.BIT.TIE  = 1;
  SCI1.SCR.BIT.RIE  = 1;
  SCI1.SCR.BIT.TE   = 1;
  SCI1.SCR.BIT.RE   = 1;
  SCI1.SCR.BIT.MPIE = 1;
  SCI1.SCR.BIT.TEIE = 1;
  SCI1.SCR.BIT.CKE  = 3;
  SCI1.TDR = 0;
  SCI1.SSR.BYTE = 0;
  SCI1.SSR.BIT.TDRE = 1;
  SCI1.SSR.BIT.RDRF = 1;
  SCI1.SSR.BIT.ORER = 1;
  SCI1.SSR.BIT.FER  = 1;
  SCI1.SSR.BIT.PER  = 1;
  SCI1.SSR.BIT.TEND = 1;
  SCI1.SSR.BIT.MPB  = 1;
  SCI1.SSR.BIT.MPBT = 1;
  SCI1.RDR = 0;
  SCI1.SCMR.BYTE = 0;
  SCI1.SCMR.BIT.SDIR = 1;
  SCI1.SCMR.BIT.SINV = 1;
  SCI1.SCMR.BIT.SMIF = 1;

  SCI2.SMR.BYTE = 0;
  SCI2.SMR.BIT.CA   = 1;
  SCI2.SMR.BIT.CHR  = 1;
  SCI2.SMR.BIT.PE   = 1;
  SCI2.SMR.BIT.OE   = 1;
  SCI2.SMR.BIT.STOP = 1;
  SCI2.SMR.BIT.MP   = 1;
  SCI2.SMR.BIT.CKS  = 3;
  SCI2.BRR = 0;
  SCI2.SCR.BYTE = 0;
  SCI2.SCR.BIT.TIE  = 1;
  SCI2.SCR.BIT.RIE  = 1;
  SCI2.SCR.BIT.TE   = 1;
  SCI2.SCR.BIT.RE   = 1;
  SCI2.SCR.BIT.MPIE = 1;
  SCI2.SCR.BIT.TEIE = 1;
  SCI2.SCR.BIT.CKE  = 3;
  SCI2.TDR = 0;
  SCI2.SSR.BYTE = 0;
  SCI2.SSR.BIT.TDRE = 1;
  SCI2.SSR.BIT.RDRF = 1;
  SCI2.SSR.BIT.ORER = 1;
  SCI2.SSR.BIT.FER  = 1;
  SCI2.SSR.BIT.PER  = 1;
  SCI2.SSR.BIT.TEND = 1;
  SCI2.SSR.BIT.MPB  = 1;
  SCI2.SSR.BIT.MPBT = 1;
  SCI2.RDR = 0;
  SCI2.SCMR.BYTE = 0;
  SCI2.SCMR.BIT.SDIR = 1;
  SCI2.SCMR.BIT.SINV = 1;
  SCI2.SCMR.BIT.SMIF = 1;

  ICI0.SMR.BYTE = 0;
  ICI0.SMR.BIT.GM   = 1;
  ICI0.SMR.BIT.CHR  = 1;
  ICI0.SMR.BIT.PE   = 1;
  ICI0.SMR.BIT.OE   = 1;
  ICI0.SMR.BIT.STOP = 1;
  ICI0.SMR.BIT.MP   = 1;
  ICI0.SMR.BIT.CKS  = 3;
  ICI0.BRR = 0;
  ICI0.SCR.BYTE = 0;
  ICI0.SCR.BIT.TIE  = 1;
  ICI0.SCR.BIT.RIE  = 1;
  ICI0.SCR.BIT.TE   = 1;
  ICI0.SCR.BIT.RE   = 1;
  ICI0.SCR.BIT.MPIE = 1;
  ICI0.SCR.BIT.TEIE = 1;
  ICI0.SCR.BIT.CKE  = 3;
  ICI0.TDR = 0;
  ICI0.SSR.BYTE = 0;
  ICI0.SSR.BIT.TDRE = 1;
  ICI0.SSR.BIT.RDRF = 1;
  ICI0.SSR.BIT.ORER = 1;
  ICI0.SSR.BIT.ERS  = 1;
  ICI0.SSR.BIT.PER  = 1;
  ICI0.SSR.BIT.TEND = 1;
  ICI0.SSR.BIT.MPB  = 1;
  ICI0.SSR.BIT.MPBT = 1;
  ICI0.RDR = 0;
  ICI0.SCMR.BYTE = 0;
  ICI0.SCMR.BIT.SDIR = 1;
  ICI0.SCMR.BIT.SINV = 1;
  ICI0.SCMR.BIT.SMIF = 1;

  ICI1.SMR.BYTE = 0;
  ICI1.SMR.BIT.GM   = 1;
  ICI1.SMR.BIT.CHR  = 1;
  ICI1.SMR.BIT.PE   = 1;
  ICI1.SMR.BIT.OE   = 1;
  ICI1.SMR.BIT.STOP = 1;
  ICI1.SMR.BIT.MP   = 1;
  ICI1.SMR.BIT.CKS  = 3;
  ICI1.BRR = 0;
  ICI1.SCR.BYTE = 0;
  ICI1.SCR.BIT.TIE  = 1;
  ICI1.SCR.BIT.RIE  = 1;
  ICI1.SCR.BIT.TE   = 1;
  ICI1.SCR.BIT.RE   = 1;
  ICI1.SCR.BIT.MPIE = 1;
  ICI1.SCR.BIT.TEIE = 1;
  ICI1.SCR.BIT.CKE  = 3;
  ICI1.TDR = 0;
  ICI1.SSR.BYTE = 0;
  ICI1.SSR.BIT.TDRE = 1;
  ICI1.SSR.BIT.RDRF = 1;
  ICI1.SSR.BIT.ORER = 1;
  ICI1.SSR.BIT.ERS  = 1;
  ICI1.SSR.BIT.PER  = 1;
  ICI1.SSR.BIT.TEND = 1;
  ICI1.SSR.BIT.MPB  = 1;
  ICI1.SSR.BIT.MPBT = 1;
  ICI1.RDR = 0;
  ICI1.SCMR.BYTE = 0;
  ICI1.SCMR.BIT.SDIR = 1;
  ICI1.SCMR.BIT.SINV = 1;
  ICI1.SCMR.BIT.SMIF = 1;

  ICI2.SMR.BYTE = 0;
  ICI2.SMR.BIT.GM   = 1;
  ICI2.SMR.BIT.CHR  = 1;
  ICI2.SMR.BIT.PE   = 1;
  ICI2.SMR.BIT.OE   = 1;
  ICI2.SMR.BIT.STOP = 1;
  ICI2.SMR.BIT.MP   = 1;
  ICI2.SMR.BIT.CKS  = 3;
  ICI2.BRR = 0;
  ICI2.SCR.BYTE = 0;
  ICI2.SCR.BIT.TIE  = 1;
  ICI2.SCR.BIT.RIE  = 1;
  ICI2.SCR.BIT.TE   = 1;
  ICI2.SCR.BIT.RE   = 1;
  ICI2.SCR.BIT.MPIE = 1;
  ICI2.SCR.BIT.TEIE = 1;
  ICI2.SCR.BIT.CKE  = 3;
  ICI2.TDR = 0;
  ICI2.SSR.BYTE = 0;
  ICI2.SSR.BIT.TDRE = 1;
  ICI2.SSR.BIT.RDRF = 1;
  ICI2.SSR.BIT.ORER = 1;
  ICI2.SSR.BIT.ERS  = 1;
  ICI2.SSR.BIT.PER  = 1;
  ICI2.SSR.BIT.TEND = 1;
  ICI2.SSR.BIT.MPB  = 1;
  ICI2.SSR.BIT.MPBT = 1;
  ICI2.RDR = 0;
  ICI2.SCMR.BYTE = 0;
  ICI2.SCMR.BIT.SDIR = 1;
  ICI2.SCMR.BIT.SINV = 1;
  ICI2.SCMR.BIT.SMIF = 1;

*/
#if 0
  AD.ADCSR.BYTE = 0;
  AD.ADCSR.BIT.ADIE = 1;
  AD.ADCSR.BIT.SCAN = 0;		/* non scan */
  AD.ADCSR.BIT.CKS  = 0;
  AD.ADCSR.BIT.CH   = 0;		/* ch0 */
  AD.ADCR.BIT.TRGE = 0;

  DA.DADR1 = 0;
  DA.DACR.BIT.DAOE1 = 1;		/* DA ch1 */

  INTC.IPRA.BIT._WDT = 1;  // Set WDT,DRAM,A/D Priority Level
#endif
}
